/*
 * Copyright (c) 1985, 1989 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	@(#)ftp_var.h	5.9 (Berkeley) 6/1/90
 */

/*
 * Include some definitions to massage the differences betweem 4.3-reno
 * and Umax.
 */
#include "compat.h"

/*
 * FTP global variables.
 */

/*
 * Options and other state info.
 */

#ifdef FTP_MAIN
# define EXTERN
#else
# define EXTERN extern
#endif

EXTERN int	trace;			/* trace packets exchanged */
EXTERN int	hash;			/* print # for each buffer transferred */
EXTERN int	sendport;		/* use PORT cmd for each data connection */
EXTERN int	verbose;		/* print messages coming back from server */
EXTERN int	connected;		/* connected to server */
EXTERN int	fromatty;		/* input is from a terminal */
EXTERN int	interactive;		/* interactively prompt on m* cmds */
EXTERN int	debug;			/* debugging level */
EXTERN int	bell;			/* ring bell on cmd completion */
EXTERN int	doglob;			/* glob local file names */
EXTERN int	autologin;		/* establish user account on connection */
EXTERN int	proxy;			/* proxy server connection active */
EXTERN int	proxflag;		/* proxy connection exists */
EXTERN int	sunique;		/* store files on server with unique name */
EXTERN int	runique;		/* store local files with unique name */
EXTERN int	mcase;			/* map upper to lower case for mget names */
EXTERN int	ntflag;			/* use ntin ntout tables for name translation */
EXTERN int	mapflag;		/* use mapin mapout templates on file names */
EXTERN int	code;			/* return/reply code for ftp command */
EXTERN int	crflag;			/* if 1, strip car. rets. on ascii gets */
EXTERN char	pasv[64];		/* passive port for proxy data connection */
EXTERN char	*altarg;		/* argv[1] with no shell-like preprocessing  */
EXTERN char	ntin[17];		/* input translation table */
EXTERN char	ntout[17];		/* output translation table */
#include <sys/param.h>
#ifndef MAXPATHLEN
#define MAXPATHLEN 128
#endif
EXTERN char	mapin[MAXPATHLEN];	/* input map template */
EXTERN char	mapout[MAXPATHLEN];	/* output map template */
EXTERN char	typename[32];		/* name of file transfer type */
EXTERN int	type;			/* requested file transfer type */
EXTERN int	curtype;		/* current file transfer type */
EXTERN char	structname[32];		/* name of file transfer structure */
EXTERN int	stru;			/* file transfer structure */
EXTERN char	formname[32];		/* name of file transfer format */
EXTERN int	form;			/* file transfer format */
EXTERN char	modename[32];		/* name of file transfer mode */
EXTERN int	mode;			/* file transfer mode */
EXTERN char	bytename[32];		/* local byte size in ascii */
EXTERN int	bytesize;		/* local byte size in binary */
EXTERN char	*hostname;		/* name of host connected to */
EXTERN int	unix_server;		/* server is unix, can use binary for ascii */
EXTERN int	unix_proxy;		/* proxy is unix, can use binary for ascii */

EXTERN struct	servent *sp;		/* service spec for tcp/ftp */
#include <setjmp.h>
EXTERN jmp_buf	toplevel;		/* non-local goto stuff for cmd scanner */

EXTERN char	line[200];		/* input line buffer */
EXTERN char	*stringbase;		/* current scan point in line buffer */
EXTERN char	argbuf[200];		/* argument storage buffer */
EXTERN char	*argbase;		/* current storage point in arg buffer */
EXTERN int	margc;			/* count of arguments on input line */
EXTERN char	*margv[20];		/* args parsed from input line */
EXTERN int     cpend;                  /* flag: if != 0, then pending server reply */
EXTERN int	mflag;			/* flag: if != 0, then active multi command */
EXTERN int	options;		/* used during socket creation */

/*
 * Format of command table.
 */
struct cmd {
	char	*c_name;	/* name of command */
	char	*c_help;	/* help string */
	char	c_bell;		/* give bell when command completes */
	char	c_conn;		/* must be connected to use command */
	char	c_proxy;	/* proxy server may execute */
	int	(*c_handler)();	/* function to call */
};

struct macel {
	char mac_name[9];	/* macro name */
	char *mac_start;	/* start of macro in macbuf */
	char *mac_end;		/* end of macro in macbuf */
};

EXTERN int macnum;			/* number of defined macros */
EXTERN struct macel macros[16];
EXTERN char macbuf[4096];

extern	char *tail();
extern	char *index();
extern	char *rindex();
extern	char *remglob();
extern	int errno;

#define strcasecmp stricmp
#define strncasecmp strnicmp
#ifdef QDOS
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <qdos.h>

#include "version.h"

extern int N_GETC(FILE *fp);
extern int N_FGETC(FILE *fp);
extern char *N_FGETS(char *buf, int len, FILE *fp);
extern int N_FPUTS(char *buf, FILE *fp);
extern int N_FPRINTF(FILE *fp, const char *format, ...);

#else
#define N_GETC getc
#define N_FGETC fgetc
#define N_FGETS fgets
#define N_PUTS puts
#define N_FPRINTF fprintf
#endif

